#!/bin/bash
#
#	4 - Create root CA and server common cert
#




########################################################
#
#Arreglem l'error en el modul de yast2 ca-mgm
########################################################


res=$(cp /etc/Linkat/data/commandline.ycp.linkat /usr/share/YaST2/include/ca-management/commandline.ycp 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error: no s'ha copiat el fitxer commandline.ycp al lloc indicat; $res"
fi

date=`date +"%d/%m/%Y %H:%M"`
echo -en "\n\n****************************************************\n"
echo "[$date] Creant root CA i certificat comú de servidor:"
echo "****************************************************"

if [ "$NOM" == "" ]; then
   NOM="servidor"
fi
if [ "$DOMINI" == "" ]; then
  DOMINI="intracentre"
fi

CA_CN="YaST Default CA ($NOM)"
CA_EMAIL="postmaster@$DOMINI"
CA_COUNTRY="ES"
CA_NAME="YaST_Default_CA"
CERT_CN="$NOM.$DOMINI"
CERT_EMAIL="postmaster@$DOMINI"
CAM_FILE="/var/lib/CAM/$CA_NAME/cam.txt"

SERIAL=`cat /var/lib/CAM/$CA_NAME/serial`
if [ "$SERIAL" = "" ]; then
   SERIAL="00"
fi

SUBJECT="/C=$CA_COUNTRY/CN=$CERT_CN/emailAddress=$CERT_EMAIL"

CERT_KEYPASS=`cat </dev/urandom | tr -dc A-Za-z0-9 | head -c8`
KEYPASS_FILE="/var/lib/CAM/.cakeypasswd"

touch $KEYPASS_FILE && chmod 600 $KEYPASS_FILE
echo $CERT_KEYPASS > $KEYPASS_FILE

res=$(/sbin/yast2 ca_mgm createCA caname="$CA_NAME" cn="$CA_CN" email="$CA_EMAIL" c="$CA_COUNTRY" keyPasswd="$CERT_KEYPASS" days=3650 2>&1)
if [ ! $? -eq 0 ];then
   echo -en "Error:: No s'ha pogut crear el certificat del CA del servidor; $res"
else
   echo -en "CA del servidor creat correctament\n"

   #
   # This *should* work, but doesn't (https://bugzilla.novell.com/show_bug.cgi?id=609449#c2)
   # We'll go around it using openssl, but when the bug is fixed it should be the way to create the cert
   #
   #   res=$(/sbin/yast2 ca_mgm createCertificate caname="$CA_NAME" type=server cn="$CERT_CN" email="$CERT_EMAIL" c="$CA_COUNTRY" keyPasswd="$CERT_KEYPASS" capasswd="$CERT_KEYPASS" days=3620 2>&1)
   #




#   res=$(expect -c "
#   set timeout 5
#   spawn openssl req -newkey rsa:2048 -keyout /var/lib/CAM/$CA_NAME/keys/commoncert.key -out /var/lib/CAM/$CA_NAME/req/commoncert.req -subj "$SUBJECT"
#   expect "PEM*"
#   send \"$CERT_KEYPASS\\r\"
#   expect "PEM*"
#   send \"$CERT_KEYPASS\\r\"
#   expect eof
#   " 2>&1)

#    res=$(openssl ca -config /var/lib/CAM/YaST_Default_CA/openssl.cnf.tmpl -in /var/lib/CAM/$CA_NAME/req/commoncert.req -out "/var/lib/CAM/$CA_NAME/certs/commoncert.pem" -days 3650 -batch -passin file:$KEYPASS_FILE 2>&1)

res=$(/sbin/yast2 ca_mgm createCertificate caname="$CA_NAME" type=server cn="$CERT_CN" email="$CERT_EMAIL" c="$CA_COUNTRY" keyPasswd="$CERT_KEYPASS" capasswd="$CERT_KEYPASS" days=3620 2>&1)
   err=""

   if [ ! $? -eq 0 ];then
         echo -en "Error:: No s'ha pogut crear el certificat del servidor; $res"
      else
         echo -en "Certificat comú del servidor creat correctament\n"

         res=$(echo "commoncert $SUBJECT" >> /var/lib/CAM/$CA_NAME/cam.txt 2>&1)
         if [ ! $? -eq 0 ];then
            err=$res
         fi
         if [ "$err" != "" ];then
            echo -en "Error(1):: Hi ha hagut algun problema a l'hora d'instal·lar el certificat comú de servidor; $res"
	    err=""
         fi
	 FILE=$(ls /var/lib/CAM/$CA_NAME/certs/)
         res=$(cp /var/lib/CAM/$CA_NAME/certs/$FILE /var/lib/CAM/$CA_NAME/newcerts/$SERIAL:commoncert.pem 2>&1)
         if [ ! $? -eq 0 ];then
            err=$res
         fi
         if [ "$err" != "" ];then
            echo -en "Error(2):: Hi ha hagut algun problema a l'hora d'instal·lar el certificat comú de servidor; $res"
	    err=""
         fi
         res=$(mkdir -p /etc/ssl/servercerts 2>&1)
         if [ ! $? -eq 0 ];then
            err=$res
         fi
         if [ "$err" != "" ];then
            echo -en "Error(3):: Hi ha hagut algun problema a l'hora d'instal·lar el certificat comú de servidor; $res"
	    err=""
         fi
	 FILE=$(ls /var/lib/CAM/$CA_NAME/certs/)
         res=$(cp /var/lib/CAM/$CA_NAME/certs/$FILE /etc/ssl/servercerts/servercert.pem 2>&1)
         if [ ! $? -eq 0 ];then
            err=$res
         fi
         if [ "$err" != "" ];then
            echo -en "Error(4):: Hi ha hagut algun problema a l'hora d'instal·lar el certificat comú de servidor; $res"
	    err=""
         fi
         res=$(cp /var/lib/CAM/$CA_NAME/cacert.pem /etc/ssl/certs/YaST-CA.pem 2>&1)
         if [ ! $? -eq 0 ];then
            err=$res
         fi
         if [ "$err" != "" ];then
            echo -en "Error(5):: Hi ha hagut algun problema a l'hora d'instal·lar el certificat comú de servidor; $res"
	    err=""
         fi
	FILE=$(ls /var/lib/CAM/$CA_NAME/keys/)      
	res=$(openssl rsa -in /var/lib/CAM/$CA_NAME/keys/$FILE -out /etc/ssl/servercerts/serverkey.pem -passin file:$KEYPASS_FILE 2>&1)
         if [ ! $? -eq 0 ];then
            err=$res
         fi
         if [ "$err" != "" ];then
            echo -en "Error(6):: Hi ha hagut algun problema a l'hora d'instal·lar el certificat comú de servidor; $res"
	    err=""
         fi
	 FILE=$(ls /var/lib/CAM/$CA_NAME/certs/)
         res=$(cp /var/lib/CAM/$CA_NAME/certs/$FILE /etc/ssl/servercerts/servercert.pem 2>&1)
         if [ ! $? -eq 0 ];then
            err=$res
         fi
         if [ "$err" != "" ];then
            echo -en "Error(7):: Hi ha hagut algun problema a l'hora d'instal·lar el certificat comú de servidor; $res"
	    err=""
         fi
         res=$(chmod 644 /etc/ssl/servercerts/servercert.pem 2>&1)
         if [ ! $? -eq 0 ];then
            err=$res
         fi
         if [ "$err" != "" ];then
            echo -en "Error(8):: Hi ha hagut algun problema a l'hora d'instal·lar el certificat comú de servidor; $res"
	    err=""
         fi
         res=$(chmod 640 /etc/ssl/servercerts/serverkey.pem 2>&1)
         if [ ! $? -eq 0 ];then
            err=$res
         fi
         if [ "$err" != "" ];then
            echo -en "Error(9):: Hi ha hagut algun problema a l'hora d'instal·lar el certificat comú de servidor; $res"
	    err=""
         fi
         res=$(setfacl -m u:ldap:r-- /etc/ssl/servercerts/serverkey.pem 2>&1)
         if [ ! $? -eq 0 ];then
            err=$res
         fi
         if [ "$err" != "" ];then
            echo -en "Error(10):: Hi ha hagut algun problema a l'hora d'instal·lar el certificat comú de servidor; $res"
	    err=""
         fi
   fi
fi


