#!/bin/bash
#
#       20 - Configure bind server
#

date=`date +"%d/%m/%Y %H:%M"`
echo -en "\n\n****************************************************\n"
echo -en "[$date] Servidor DNS \n"
echo "****************************************************"

echo -en "Establint permisos correctes a /var/lib/named: "
res=$(chown -R named.named /var/lib/named/var /var/lib/named/log)
if [ ! $? -eq 0 ];then
	echo -en "Error:: S'ha produït un error al canviar els permisos de /var/lib/named; $res"
else
	echo -en "Ok\n"
fi

# It's supposed that the machine IP is alrady configures in 003_networkconfig.sh ...
echo -en "Obtenint adreça de la màquina:"
ip=$(/sbin/ifconfig | grep "inet addr" | grep -v "127.0.0.1"| awk '{print $2}' | cut -d ":" -f 2 | head -1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: No s'ha pogut llegir l'adreça de la màquina"
fi

if [ -e /etc/named.conf ];then
	res=$(cp /etc/named.conf /etc/Linkat/backup/named.conf.orig 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error:: S'ha produït un error al fer la còpia de seguretat del fitxer /etc/named.conf; $res"
	else
		echo -en "S'ha fet una còpia de seguretat de la configuració DNS /etc/named.conf\n"
	fi
fi

echo -en "S'està fent una còpia de seguretat de la configuració DNS /etc/sysconfig/named: "
if [ -e /etc/sysconfig/named ];then
	res=$(cp /etc/sysconfig/named /etc/Linkat/backup/named.orig 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error:: S'ha produït un error al fer la còpia de seguretat del fitxer /etc/sysconfig/named; $res"
	else
		echo -en "Ok\n"
	fi
fi

echo -en "S'està fent una còpia de seguretat de la configuració DNS /etc/named.d/forwarders.conf: "
if [ -e /etc/named.d/forwarders.conf ];then
	res=$(mv /etc/named.d/forwarders.conf /etc/Linkat/backup/forwarders.conf.orig 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error:: S'ha produït un error al fer la còpia de seguretat del fitxer /etc/named.d/forwarders.conf; $res"
	else
		echo -en "Ok\n"
	fi
fi

IP1=$(echo $ip | cut -d "." -f 1 2>&1)
IP2=$(echo $ip | cut -d "." -f 2 2>&1)
IP3=$(echo $ip | cut -d "." -f 3 2>&1)
IP4=$(echo $ip | cut -d "." -f 4 2>&1)

echo -en "Aplicant la configuració a /etc/sysconfig/named"
res=$(cat /etc/Linkat/data/sysconfig.named | sed s/__SERVDOM__/$DOMINI/g | sed s/__IP3__/$IP3/g | sed s/__IP2__/$IP2/g | sed s/__IP1__/$IP1/g >/etc/sysconfig/named 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: S'ha produït un error en configurar el fitxer /etc/sysconfig/named; $res"
else
	echo -en "Ok\n"
fi

echo -en "S'està configurant la zona DNS $DOMINI: "
res=$(cat /etc/Linkat/data/dns_zona.conf | sed s/__DOMINI__/$DOMINI/g >/etc/named.d/$DOMINI 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: S'ha produït un error configurar la zona del domini $DOMINI del servidor DNS; $res"        
else
	echo -en "Ok\n"
fi

echo -en "Canviant el propietari al fitxer de zona $DOMINI: "
res=$(chown root.named /etc/named.d/$DOMINI 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Warning:: S'ha produït un error al establir el propietari al fitxer de zona $DOMINI"
else
	echo -en "Ok\n"
fi

echo -en "Aplicant permisos al fitxer de configuració de la zona $DOMINI: "
res=$(chmod 664 /etc/named.d/$DOMINI 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Warning:: S'ha produit un error al establir els permissos de la configuració de la zona $DOMINI; $res" 
else
	echo -en "Ok\n"
fi

echo -en "Configuració de la zona $IP3.$IP2.$IP1.in-addr.arpa: "
res=$(cat /etc/Linkat/data/dns_zona_rev.conf | sed s/__IP3__/$IP3/g | sed s/__IP2__/$IP2/g |sed s/__IP1__/$IP1/g >/etc/named.d/$IP3.$IP2.$IP1.in-addr.arpa 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: S'ha produït un error configurar la zona reversa $IP3.$IP2.$IP1.in-addr.arpa  del servidor DNS; $res"        
else
	echo -en "Ok\n"
fi

echo -en "Canviant el propietari al fitxer de zona $IP3.$IP2.$IP1.in-addr.arpa: "
res=$(chown root.named /etc/named.d/$IP3.$IP2.$IP1.in-addr.arpa 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Warning:: S'ha produït un error al establir el propietari al fitxer de zona $IP3.$IP2.$IP1.in-addr.arpa"
else
	echo -en "Ok\n"
fi

echo -en "Aplicant permisos al fitxer de configuració de la zona $IP3.$IP2.$IP1.in-addr.arpa: "
res=$(chmod 664 /etc/named.d/$IP3.$IP2.$IP1.in-addr.arpa 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Warning:: S'ha produit un error al establir els permisos de la configuració de la zona $IP3.$IP2.$IP1.in-addr.arpa; $res" 
else
	echo -en "Ok\n"
fi

echo -en "Copiant fitxer named.conf: "
res=$(cp /etc/Linkat/data/named.conf.Linkat /etc/named.conf)
if [ ! $? -eq 0 ];then
	echo -en "Error:: S'ha produït un error en copiar el fitxer named.conf; $res"
else
	echo -en "Ok\n"
fi

echo -en "Aplicant permisos del fitxer de configuració del servidor DNS: "
res=$(chmod 664 /etc/named.conf 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Warning:: S'ha produit un error al establir els permisos de la configuracióervidor DNS; $res" 
else
	echo -en "Ok\n"
fi

echo -en "Creant el reverse DNS del servidor\n"
if [ -e /var/lib/named/master/$IP3.$IP2.$IP1.in-addr.arpa ];then
	echo -en "Fent copia de seguretat:"
	res=$(mv /var/lib/named/master/$IP3.$IP2.$IP1.in-addr.arpa /etc/Linkat/backup/$IP3.$IP2.$IP1.in-addr.arpa.orig 2>&1) 
	if [ ! $? -eq 0 ];then
		echo -en "Error:: No s'ha pogut fer una copia de seguretat de l'actual reverse DNS"
	else
		echo -en "Ok\n"
	fi
fi

res=$(cat /etc/Linkat/data/rev.in-addr.arpa.Linkat | sed s/__SERVDOM__/$NOM\.$DOMINI/g | sed s/__IP4__/$IP4/g | sed s/__IP3__/$IP3/g | sed s/__IP2__/$IP2/g | sed s/__IP1__/$IP1/g  > /var/lib/named/master/$IP3.$IP2.$IP1.in-addr.arpa 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: S'ha produït un error al crear el reverse DNS; $res\n" 
else
	echo -en "Ok\n"
fi

echo -en "Establint permisos del fitxer del reverse DNS: "
res=$(chmod 664 /var/lib/named/master/$IP3.$IP2.$IP1.in-addr.arpa 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: S'ha produït un error al establir els permissos al fitxer del reverse DNS; $res\n" 
else
	echo -en "Ok\n"
fi

echo -en "Creant la zona $DOMINI:\n"
if [ -e /var/lib/named/master/$DOMINI ];then
	echo -en "Fent còpia de seguretat de la zona $DOMINI:"
	res=$(mv /var/lib/named/master/$DOMINI /etc/Linkat/backup/$DOMINI.orig 2>&1) 
	if [ ! $? -eq 0 ];then
		echo -en "Error:: No s'ha pogut fer una copia de seguretat de l'actual zona '$DOMINI'\n"
	else
		echo -en "Ok\n"
	fi
fi

res=$(cat /etc/Linkat/data/zona.Linkat | sed s/__SERVDOM__/$NOM\.$DOMINI/g | sed s/__NOM__/$NOM/g | sed s/__IP4__/$IP4/g | sed s/__IP3__/$IP3/g | sed s/__IP2__/$IP2/g | sed s/__IP1__/$IP1/g> /var/lib/named/master/$DOMINI 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: S'ha produït un error al crear la zona DNS $DOMINI; $res" 
else
	echo -en "Ok\n"
fi

echo -en "Establint permisos del fitxer de zona $DOMINI: "
res=$(chown root.named /var/lib/named/master/$DOMINI 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "\n\tError:: S'ha produït un error al establir el propietari del fitxer de zona '$DOMINI'; $res"
else
	echo -en "Ok\n"
fi

res=$(chmod 664 /var/lib/named/master/$DOMINI 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: S'ha produït un error al establir els permisos del fitxer de zona '$DOMINI'; $res" 
else
	echo -en "Ok\n"
fi

echo -en "Executant netconfig per aplicar configuracions del bind: "
res=$(netconfig update)
if [ ! $? -eq 0 ];then
	echo -en "Error:: S'ha produït un error en configurar els reenviadors $reenviadors del DNS; $res"
else
	echo -en "Ok\n"
fi

res_code=0
echo -en "Aplicant canvis al servidor DNS\n"
res=$(rcnamed status 2>&1)
	case $? in
	1)
		res=$(rcnamed start 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
	3)
		res=$(rcnamed start 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
	0)
		res=$(rcnamed reload 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
	*)
	res=$(rcnamed reload 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
	esac

if [ ! $res_code = 0 ];then
	echo -en "Error:: No s'han pogut aplicar correctament els canvis del servidor DNS; $res\n"
else
	echo -en "Afegint el servei DNS a chkconfig\n"
	res=$(chkconfig --add named 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error:: No s'ha pogut posar el servei DNS al chkconfig\n"
	else
		echo -en "Ok\n"
	fi      
fi

