#!/bin/bash
#
#       40 - Configure NTP server 
#

date=`date +"%d/%m/%Y %H:%M"`
echo -en "\n\n****************************************************\n"
echo -en "[$date] Servidor NTP \n"
echo "****************************************************"

if [ -e /etc/ntp.conf ];then
		echo -en "Fent còpia de seguretat de la configuració NTP: "
		res=$(cp /etc/ntp.conf /etc/Linkat/backup/ntp.conf.orig 2>&1)
		if [ ! $? -eq 0 ];then
			echo -en "Error:: S'ha produït un error al aplicar els canvis del servidor NTP; $res"
		else
			echo -en "Ok\n"
		fi
fi

echo -en "Aplicant configuració de la Linkat:\n"
res=$(cp -f /etc/Linkat/data/ntp.conf.Linkat  /etc/ntp.conf 2>&1)
if [ ! $? -eq 0 ];then
		echo -en "Error:S'ha produït un error al aplicar els canvis del servidor NTP; $res"
	else
		res_code=0
		echo "Aplicant els canvis:"
		res=$(rcntp status 2>&1)
		case $? in
			3)
			nohup rcntp start 2>&1 &
			;;
			0)
			nohup rcntp restart 2>&1 &
			;;
			*)
			res_code=1
			;;
		esac
		if [ $res_code -ne 0 ];then
			echo -en "Error:: S'ha produït un error al aplicar els canvis del servidor NTP: $res"
		else
			echo -en "Afegint servei NTP a la seqüència d'init\n"
			res=$(chkconfig --add ntp 2>&1)
			if [ ! $? -eq 0 ];then
				echo -en "Error:: No s'ha pogut posar el servei NTP a la seqüència d'init\n"
			else
				echo -en "Success: S'ha configurat correctament el servei de temps\n"
			fi
		fi
fi

