#!/bin/bash
#
# Zenity GUI to setup hostname and domain giving a default value.
#
# Author: Jordi "Txor" Casas Rios <jordi.casas@opentrends.net>
#         Jordi Massaguer Pla <jordi.massaguer@opentrends.net>
#

ZENITY=$(which zenity)
HOSTNAME_FILE=/etc/Linkat/data/HOSTNAME.Linkat
HOSTNAME_FILES="/etc/Linkat/data/hosts.Linkat /etc/Linkat/data/ldap.conf.Linkat /etc/Linkat/data/openSUSE-update.repo.Linkat /etc/Linkat/data/sysconfig.ldap /etc/Linkat/data/ldapconfig.ldif.Linkat /etc/Linkat/data/grups.ldif.Linkat" 

HOSTNAME=$(cat $HOSTNAME_FILE | cut -d '.' -f 1)
DOMAIN=$(cat $HOSTNAME_FILE | cut -d '.' -f 2)
NEW_HOSTNAME=$($ZENITY --title="hostname" --entry --text="Escolliu el nom de host." --entry-text="$HOSTNAME")
NEW_DOMAIN=$($ZENITY --title="domain" --entry --text="Escolliu el nom del domini." --entry-text="$DOMAIN")
echo $NEW_HOSTNAME.$NEW_DOMAIN > /etc/Linkat/data/HOSTNAME.Linkat
for file in $HOSTNAME_FILES
do
echo "replacing $HOSTNAME by $NEW_HOSTNAME at $file"
echo "replacing $DOMAIN by $NEW_DOMAIN at $file"
sed -e"s/$HOSTNAME/$NEW_HOSTNAME/g" -i $file
sed -e"s/$DOMAIN/$NEW_DOMAIN/g" -i $file
done

