#!/bin/bash
#
#       50 - Restore SAMBA Server
#

echo "#Servidor SAMBA"

if [ -e /etc/openldap/slapd.d/cn\=config/cn\=schema/cn\={?}samba3.ldif ];then
	echo "si"
	res=$(rm /etc/openldap/slapd.d/cn\=config/cn\=schema/cn\={?}samba3.ldif 2>&1)
	if [ ! $? -eq 0 ];then
		echo -e "\n\tError:: S'ha produit un error al esborrar el fitxer schema de samba3; $res"
	else
		echo -e "Ok\n"
	fi	
fi

if [ ! -e /etc/Linkat/backup/smb.conf.orig ];then
	echo -e "\n\tWarning: No hi ha cap còpia de seguretat del servei samba. Es deixa la configuració actual."
else
	echo -e "S'està restaurant còpia de seguretat del servei samba:"
	res=$(mv /etc/Linkat/backup/smb.conf.orig /etc/samba/smb.conf 2>&1)
	if [ ! $? -eq 0 ];then
		echo -e "\n\tError:: S'ha produit un error al restaurar la configuració Samba; $res"
	else
		echo -e "Ok\n"
	fi
fi

if [ -e /etc/Linkat/backup/secrets.tdb.orig ];then
	echo -e "Restaurant còpia de seguretat del fitxer secrets.tdb:"
	res=$(mv /etc/Linkat/backup/secrets.tdb.orig /etc/samba/secrets.tdb 2>&1)
	if [ ! $? -eq 0 ];then
		echo -e "Error:: No s'ha pogut restaurar la copia de seguretat de passwords de Samba"
	else
		echo -e "Ok\n"
	fi
fi


echo -e "Aplicant configuració:"
res_code=0
res=$(rcsmb status 2>&1)
case $? in
	0)
		res=$(rcsmb stop && rcnmb stop 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
	*)
		res_code=1
	;;
esac
if [ $res_code -ne 0 ];then
	echo -e "\n\tError:: S'ha produït un error al aplicar els canvis del servidor Samba: $res"
else
	echo -e "Ok\n"
	echo "S'està eliminant el servei de samba de la seqüència d'inici:"
	res=$(chkconfig --del smb && chkconfig --del nmb 2>&1)
	if [ ! $? -eq 0 ];then
		echo -e "\n\tError:: No s'ha pogut treure el servei Samba de la seqüència d'init: $res"
	else
		echo -e "Ok\n"
		echo -e "\n\tSuccess: S'ha restaurat correctament la configuració de Samba"
	fi
fi


