#!/bin/bash
#
#       65 - Restore DNS Server
#

echo "\n\t#Servidor DNS#\n"

if [ ! -e /etc/Linkat/backup/named.conf.orig ];then
	echo -e "\n\tWarning: No hi ha cap còpia de seguretat del servidor DNS. Es deixa la configuració actual."
else
	echo -e "S'està restaurant la còpia de seguretat de la configuració de servidor DNS"
	res=$(mv /etc/Linkat/backup/named.conf.orig /etc/named.conf 2>&1)
	if [ ! $? -eq 0 ];then
		echo "Error:: S'ha produït un error al restaurar la configuració DNS; $res"
	else
		echo -e "Ok\n"
		if [ -e /etc/Linkat/backup/$DOMINI.orig ];then
			echo -e "Restaurant la configuració de zona \"$DOMINI\""
			res=$(mv /etc/Linkat/backup/$DOMINI.orig  /var/lib/named/master/$DOMINI 2>&1)
			if [ ! $? -eq 0 ];then
				echo -e "\n\tError:: S'ha produït un error al restaurar la configuració DNS; $res"
			else
				echo -e "Ok\n"
			fi
		fi

		if [ -e /etc/Linkat/backup/$IP4.$IP3.$IP2.$IP1.in-addr.arpa.orig ];then
			echo -e "S'està restaurant la configuració del reverse DNS"
			res=$(mv /etc/Linkat/backup/$IP4.$IP3.$IP2.$IP1.in-addr.arpa.orig  /var/lib/named/master/$IP4.$IP3.$IP2.$IP1.in-addr.arpa 2>&1)
			if [ ! $? -eq 0 ];then
				echo -e "\n\tError:: S'ha produït un error al restaurar la configuració del reverse DNS; $res"
			else
				echo -e "Ok\n"
			fi
		fi
                if [ -e /etc/Linkat/backup/forwarders.conf.orig ];then
                        echo -e "S'està restaurant la configuració dels reenviadors de DNS"
                        res=$(mv /etc/Linkat/backup/forwarders.conf.orig  /etc/named.d/forwarders.conf 2>&1)
                        if [ ! $? -eq 0 ];then
                                echo -e "\n\tError:: S'ha produït un error al restaurar la configuració dels reenviadors de DNS; $res"
                        else
                                echo -e "Ok\n"
                        fi
                fi
                if [ -e /etc/Linkat/backup/named.orig ];then
                        echo -e "S'està restaurant la configuració del servei DNS"
                        res=$(mv /etc/Linkat/backup/named.orig  /etc/sysconfig/named 2>&1)
                        if [ ! $? -eq 0 ];then
                                echo -e "\n\tError:: S'ha produït un error al restaurar la configuració del servei de DNS; $res"
                        else
                                echo -e "Ok\n"
                        fi
                fi
                if [ -e /var/lib/named/master/$DOMINI ];then
                        echo -e "S'està eliminant la zona directa del DNS"
                        res=$(rm /var/lib/named/master/$DOMINI && rm /etc/named.d/$DOMINI 2>&1)
                        if [ ! $? -eq 0 ];then
                                echo -e "\n\tError:: S'ha produït un error al eliminar el fitxer de zona directa del DNS; $res"
                        else
                                echo -e "Ok\n"
                        fi
                fi
                if [ -e /var/lib/named/master/$IP3.$IP2.$IP1.in-addr.arpa ];then
                        echo -e "S'està eliminant la zona inversa del DNS"
                        res=$(rm  /var/lib/named/master/$IP3.$IP2.$IP1.in-addr.arpa && rm /etc/named.d/$IP3.$IP2.$IP1.in-addr.arpa 2>&1)
                        if [ ! $? -eq 0 ];then
                                echo -e "\n\tError:: S'ha produït un error al eliminar el fitxer de zona inversa del DNS; $res"
                        else
                                echo -e "Ok\n"
                        fi
                fi
                if [ -e /etc/named.conf.include ];then
                        echo -e "S'està eliminant el fitxer include del DNS"
                        res=$(rm -f /etc/named.conf.include 2>&1)
                        if [ ! $? -eq 0 ];then
                                echo -e "\n\tError:: S'ha produït un error al eliminar el fitxer include del DNS; $res"
                        else
                                echo -e "Ok\n"
                        fi
                fi

		res_code=0
		echo -e "S'està aplicant canvis al servidor DNS"
		res=$(rcnamed status 2>&1)
		case $? in
			0)
				res=$(rcnamed stop 2>&1)
				if [ ! $? -eq 0 ];then
					res_code=1
				fi
			;;
			*)
				res=$(rcnamed reload 2>&1)
				if [ ! $? -eq 0 ];then
					res_code=1
				fi
			;;
		esac
		if [ ! $res_code = 0 ];then
			echo -e "\n\tError:: No s'han pogut aplicar correctament els canvis del servidor DNS;$res"
		else
			echo -e "Ok\n"
			echo -e "S'està eliminant el servei DNS de la seqüència d'inici"
			res=$(chkconfig --del named 2>&1)
			if [ ! $? -eq 0 ];then
				echo -e "\n\tError:: No s'ha pogut treure el servei DNS de la seqüència d'init"
			else
				echo -e "Ok\n"
				echo -e "\n\tSuccess:: S'ha reconfigurat correctament el servidor DNS"
			fi
		fi
        fi
fi

