#!/bin/bash
#
#       82 - lnadmin privilege drop
#

echo -e "\n\t# lnadmin privilege drop #\n"

echo -e "Revocant permisos d'escriptura a la unitat S"
res=$(setfacl -x user:lnadmin:rwx /srv/exports/S 2>&1)
if [ ! $? -eq 0 ];then
	echo -e "Error:: Problemes revocant ACL a /srv/exports/S ; $res"
else
	echo -e "Ok\n"
	echo -e "\n\tSuccess: Permisos d'escriptura sobre la unitat S revocats satisfactòriament\n"
fi

echo -e "Revocant permisos d'escriptura a la unitat G"
res=$(setfacl -x user:lnadmin:rwx /srv/exports/G 2>&1)
if [ ! $? -eq 0 ];then
	echo -e "Error:: Problemes revocant ACL a /srv/exports/G ; $res"
else
	echo -e "Ok\n"
	echo -e "\n\tSuccess: Permisos d'escriptura sobre la unitat G revocats satisfactòriament\n"
fi


# Sudoers setup for yast2 graphical module access
echo -e "Revocant permisos d'administració de varis mòduls de yast a lnadmin"
if [ -e /etc/Linkat/backup/sudoers.orig ];then
        echo -e "Restablint còpia de seguretat del sudoers original:"
        res=$(cp -f /etc/Linkat/backup/sudoers.orig /etc/sudoers 2>&1)
        if [ ! $? -eq 0 ];then
		echo -e "\n\tError:: S'ha produït un error al restablir el backup del fitxer sudoers; $res"
	else
		echo -e "Ok\n"
	fi
else
	echo -e "\n\tWarning: No s'ha pogut restablir el fitxer sudoers original, es manté la configuració actual"
fi 



# Policykit permissions revoking
echo -e "Revocant permisos de policykit per la impressora"
res=$(polkit-auth --user lnadmin --revoke org.opensuse.cupspkhelper.mechanism.server-settings 2>&1)
if [ ! $? -eq 0 ];then
	echo -e "Error:: No s'ha pogut revocar l'autorització a lnadmin per canviar server-settings; $res"
else
	echo -e "Ok\n"
	echo -e "\n\tSuccess: autorització revocada per canviar la configuració del CUPS\n"
fi

res=$(polkit-auth --user lnadmin --revoke org.opensuse.cupspkhelper.mechanism.printeraddremove 2>&1)
if [ ! $? -eq 0 ];then
	echo -e "Error:: No s'ha pogut revocar l'autorització a lnadmin per afegir i eliminar impressores; $res"
else
	echo -e "Ok\n"
	echo -e "\n\tSuccess: autorització revocada per afegir i eliminar impressores\n"
fi

res=$(polkit-auth --user lnadmin --revoke org.opensuse.cupspkhelper.mechanism.printer-set-default 2>&1)
if [ ! $? -eq 0 ];then
	echo -e "Error:: No s'ha pogut revocar l'autorització a lnadmin per canviar la impressora per defecte; $res"
else
	echo -e "Ok\n"
	echo -e "\n\tSuccess: autorització revocada per canviar la impressora per defecte\n"
fi

res=$(polkit-auth --user lnadmin --revoke org.opensuse.cupspkhelper.mechanism.printer-remote-edit 2>&1)
if [ ! $? -eq 0 ];then
	echo -e "Error:: No s'ha pogut revocar l'autorització a lnadmin per modificar una impressora remota; $res"
else
	echo -e "Ok\n"
	echo -e "\n\tSuccess: autorització revocada per modificar una impressora remota\n"
fi


res=$(polkit-auth --user lnadmin --revoke org.opensuse.cupspkhelper.mechanism.printer-local-edit 2>&1)
if [ ! $? -eq 0 ];then
	echo -e "Error:: No s'ha pogut revocar l'autorització a lnadmin per canviar les impressores locals; $res"
else
	echo -e "Ok\n"
	echo -e "\n\tSuccess: autorització revocada per canviar les impressores locals\n"
fi

res=$(polkit-auth --user lnadmin --revoke org.opensuse.cupspkhelper.mechanism.printer-enable 2>&1)
if [ ! $? -eq 0 ];then
	echo -e "Error:: No s'ha pogut revocar l'autorització a lnadmin per habilitar impressores; $res"
else
	echo -e "Ok\n"
	echo -e "\n\tSuccess: autorització revocada per habilitar i deshabilitar impressores\n"
fi

res=$(polkit-auth --user lnadmin --revoke org.opensuse.cupspkhelper.mechanism.class-edit 2>&1)
if [ ! $? -eq 0 ];then
	echo -e "Error:: No s'ha pogut revocar l'autorització per editar classes d'impressió; $res"
else
	echo -e "Ok\n"
	echo -e "\n\tSuccess: autorització revocada per canviar classes d'impressió\n"
fi



# Clock applet permissions
echo -e "Revocant l'autorització de lnadmin a canviar l'hora i fus horari del sistema"
res=$(polkit-auth --user lnadmin --revoke org.gnome.clockapplet.mechanism.settimezone 2>&1)
if [ ! $? -eq 0 ];then
	echo -e "Error:: No s'ha pogut revocar l'autorització per canviar el fus horari del sistema; $res"
else
	echo -e "Ok\n"
	echo -e "\n\tSuccess: autorització revocada per canviar el fus horari del sistema\n"
fi

res=$(polkit-auth --user lnadmin --revoke org.gnome.clockapplet.mechanism.settime 2>&1)
if [ ! $? -eq 0 ];then
	echo -e "Error:: No s'ha pogut revocar l'autorització per canviar l'hora del sistema; $res"
else
	echo -e "Ok\n"
	echo -e "\n\tSuccess: autorització revocada per canviar l'hora del sistema (settime)\n"
fi

res=$(polkit-auth --user lnadmin --revoke org.gnome.clockapplet.mechanism.configurehwclock 2>&1)
if [ ! $? -eq 0 ];then
	echo -e "Error:: No s'ha pogut autoritzar lnadmin per canviar el rellotge del sistema; $res"
else
	echo -e "Ok\n"
	echo -e "\n\tSuccess: autorització revocada per canviar l'hora del sistema (hwclock)\n"
fi


# Package updates
echo -e "Revocant l'autorització de lnadmin a actualitzar el sistema"
res=$(polkit-auth --user lnadmin --revoke org.freedesktop.packagekit.system-update 2>&1)
if [ ! $? -eq 0 ];then
	echo -e "Error:: No s'ha pogut autoritzar lnadmin per actualitzar el sistema; $res"
else
	echo -e "Ok\n"
	echo -e "\n\tSuccess: autorització revocada (system-update)\n"
fi

echo -e "Revocant l'autorització de lnadmin a confiar en claus de firma"
res=$(polkit-auth --user lnadmin --revoke org.freedesktop.packagekit.system-trust-signing-key 2>&1)
if [ ! $? -eq 0 ];then
	echo -e "Error:: No s'ha pogut revocar l'autorització; $res"
else
	echo -e "Ok\n"
	echo -e "\n\tSuccess: autorització revocada (system-trust-signing-key)\n"
fi

echo -e "Revocant l'autorització de lnadmin a configurar el proxy de xarxa"
res=$(polkit-auth --user lnadmin --revoke org.freedesktop.packagekit.system-network-proxy-configure 2>&1)
if [ ! $? -eq 0 ];then
	echo -e "Error:: No s'ha pogut revocar l'autorització; $res"
else
	echo -e "Ok\n"
	echo -e "\n\tSuccess: autorització revocada (system-network-proxy-configure)\n"
fi

echo -e "Revocant l'autorització de lnadmin a acceptar llicències d'un nou paquet"
res=$(polkit-auth --user lnadmin --revoke org.freedesktop.packagekit.package-eula-accept 2>&1)
if [ ! $? -eq 0 ];then
	echo -e "Error:: No s'ha pogut revocar l'autorització; $res"
else
	echo -e "Ok\n"
	echo -e "\n\tSuccess: autorització revocada (package-eula-accept)\n"
fi





#
# Linkat backup scripts remove
#
# Backup script remove
echo -e "Eliminant script de backup automàtic"
if [ -e /usr/bin/linkat_backup.sh ];then
	res=$(rm -f /usr/bin/linkat_backup.sh 2>&1)
	if [ ! $? -eq 0 ];then
		echo -e "Error:: No s'ha pogut eliminar correctament /usr/bin/linkat_backup.sh; $res"
	else
		echo -e "Ok\n"
		echo -e "\n\tSuccess: Eliminat /usr/bin/linkat_backup.sh\n"
	fi
else
	echo -e "Error:: No s'ha trobat el fitxer /usr/bin/linkat_backup.sh al sistema; $res"
fi



# Backup config
echo -e "Eliminant configuració de l'script de backup automàtic"
if [ -e /etc/sysconfig/linkat_backup ];then
	res=$(rm -f /etc/sysconfig/linkat_backup 2>&1)
	if [ ! $? -eq 0 ];then
		echo -e "Error:: No s'ha pogut eliminar correctament /etc/sysconfig/linkat_backup; $res"
	else
		echo -e "Ok\n"
		echo -e "\n\tSuccess: Eliminat /etc/sysconfig/linkat_backup\n"
	fi
else
	echo -e "Error:: No s'ha trobat el fitxer /etc/sysconfig/linkat_backup; $res"
fi



# Backup cron
echo -e "Eliminant cron de l'script de backup"
if [ -e /etc/cron.d/linkat_backup ];then
        res=$(rm -f /etc/cron.d/linkat_backup 2>&1)
        if [ ! $? -eq 0 ];then
                echo -e "Error:: No s'ha pogut eliminar correctament /etc/cron.d/linkat_backup; $res"
        else
                echo -e "Ok\n"
                echo -e "\n\tSuccess: Eliminat /etc/cron.d/linkat_backup\n"
        fi
else
        echo -e "Error:: No s'ha trobat el fitxer /etc/cron.d/linkat_backup; $res"
fi


